function varargout = clustering_gui(varargin)
%CLUSTERING_GUI M-file for clustering_gui.fig
%      CLUSTERING_GUI, by itself, creates a new CLUSTERING_GUI or raises the existing
%      singleton*.
%
%      H = CLUSTERING_GUI returns the handle to a new CLUSTERING_GUI or the handle to
%      the existing singleton*.
%
%      CLUSTERING_GUI('Property','Value',...) creates a new CLUSTERING_GUI using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to clustering_gui_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      CLUSTERING_GUI('CALLBACK') and CLUSTERING_GUI('CALLBACK',hObject,...) call the
%      local function named CALLBACK in CLUSTERING_GUI.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustering_gui

% Last Modified by GUIDE v2.5 28-Apr-2016 11:17:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustering_gui_OpeningFcn, ...
    'gui_OutputFcn',  @clustering_gui_OutputFcn, ...
    'gui_LayoutFcn',  [], ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes during object creation, after setting all properties.
function percent_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to percent_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes just before clustering_gui is made visible.
function clustering_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for clustering_gui
handles.output = hObject;

if length(varargin) ~= 1
    error('Incorrect number of arguments.');
end

handles.ALLEEG = varargin{1};

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes clustering_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = clustering_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Collect all the outputs
varargout{1} = [handles.ALLEEG];

% The figure can be deleted now
delete(handles.figure1);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure

if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end


% --- Executes on button press in go_button.
function go_button_Callback(hObject, eventdata, handles)
% hObject    handle to go_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ***** Execute clustering *****

handles.prompt_text.String = 'Clustering...DO NOT CLOSE.';

ALLEEG = handles.ALLEEG;
range = [str2double(handles.min_clusters.String) str2double(handles.max_clusters.String)];

%% Cluster individual maps
if handles.individual.Value == 1
    fprintf('\nClustering individual maps...\n');
    for i = 1:length(ALLEEG)
        
        % create individual_microstate_maps if they are not already there
        if ~isfield(ALLEEG,'individual_microstate_maps')
        ALLEEG(i).individual_microstate_maps = [];
        end
        
        fprintf(['Clustering file ',num2str(i),' of ',num2str(length(ALLEEG)),'.\n']);
        data = [];
        
        % concatenate all the gfp peaks
        for j = 1:length(ALLEEG(i).gfp_peaks)
            data = cat(2,data,ALLEEG(i).gfp_peaks{j});
        end
        
        if handles.kmeans.Value == 1 % do Kmeans clustering
            
            % pass this to find_microstates_kmeans for each number of clusters in range
            for j = range(1):range(2)
                
                % Using K-means clustering
                [best_maps,~,~] = find_microstates_kmeans(data',j,5,2000);
                
                % put this back into ALLEEG
                ALLEEG(i).individual_microstate_maps{j} = best_maps';
                
            end
            
        else % do taahc clustering
            
            best_maps = find_microstates_taahc(data',range);
            
            for j = range(1):range(2)
                ALLEEG(i).individual_microstate_maps{j} = best_maps{j}';
            end
            
        end
        
    end
    
    assignin('base','ALLEEG',ALLEEG);
    
end

% In case we are using the 'percent maps' method,
if handles.percent_originals.Value == 1
    fewest_maps = 1;
    % Find the file with the fewest original maps
    for i=2:length(ALLEEG)
        if size(cat(2,ALLEEG(i).gfp_peaks{:})) < size(cat(2,ALLEEG(fewest_maps).gfp_peaks{:}))
            fewest_maps = i;
        end
    end
    % How many maps should be selected from each file?
    select_this_many = round(size(cat(2,ALLEEG(fewest_maps).gfp_peaks{:}),2)*str2double(handles.percent_edit.String)/100);
    fprintf(['Using percent maps method. Extracting ',num2str(select_this_many),' maps from each dataset.\n']);
end

%% Cluster by groups
need_to_cluster = 0;
if handles.group.Value == 1
    fprintf('\nClustering group maps...\n');
    % Create a group_microstates if it's not already there
    if ~isfield(ALLEEG,'group_microstate_maps')
    ALLEEG(1).group_microstate_maps = [];
    end
    % Concatenate the group clusters
    group_labels = cat(1,{ALLEEG.group});
    % Remove the empty groups and convert to strings
    for i = 1:length(group_labels)
        if isnumeric(group_labels{i})
            group_labels{i} = num2str(group_labels{i});
        end
        if isempty(group_labels{i})
            group_labels{i} = '';
        end
    end
    % Find the unique group_labels, and eliminate blank groups
    unique_groups = unique(group_labels);
    unique_groups(strcmp(unique_groups,'')) = [];
    
    for i = 1:length(unique_groups) % FOR EACH GROUP
        
        fprintf(['\nGROUP ',num2str(i),'\n']);
        
        % Get members of this group
        fprintf(['Getting members of group ',num2str(i),'...']);
        idx = strcmp(group_labels,unique_groups(i));
        GROUPEEG = ALLEEG(idx);
        fprintf('Done.\n');
        
        for j = range(1):range(2) % For each number of microstates,
            
            fprintf(['\nFinding ',num2str(j),' clusters within group ',num2str(i),'...\n']);
            
            % Get group data to cluster
            group_clusters = [];
            % All original maps
            if handles.all_maps.Value == 1
                fprintf(' >> Clustering all individual maps\n');
                for k = 1:length(GROUPEEG)
                    for t = 1:size(GROUPEEG(k).gfp_peaks,2)
                        group_clusters = cat(2,group_clusters,GROUPEEG(k).gfp_peaks{t});
                    end
                end
                need_to_cluster = 1;
            end
            % Cluster individual clusters
            if handles.clust_ind_maps.Value == 1
                fprintf(' >> Clustering individual clusters\n');
                for k = 1:length(GROUPEEG)
                    group_clusters = cat(2,group_clusters,GROUPEEG(k).individual_microstate_maps{j});
                end
                need_to_cluster = 1;
            end
            % Percent original maps
            if handles.percent_originals.Value == 1
                fprintf(' >> Clustering using percent originals method\n');
                for k = 1:length(GROUPEEG)
                    group_clusters = cat(2,group_clusters,datasample(cat(2,GROUPEEG(k).gfp_peaks{:}),select_this_many,2));
                end
                need_to_cluster = 1;
            end
            
            % Cluster if need to cluster
            if need_to_cluster == 1
                fprintf(' >> Initializing clustering\n');
    
                if handles.kmeans.Value == 1
                    [group_clusters,~,~] = find_microstates_kmeans(group_clusters',j,5,2000);
                else
                    group_clusters = find_microstates_taahc(group_clusters',[j j]);
                    group_clusters = group_clusters{j};
                end
            end
            
            % Average individual clusters
            if handles.avg_ind_maps.Value == 1
                fprintf(' >> Averaging indidividual clusters\n');
                
                % Generate map matrix
                    maps = [];
                    for k = 1:length(GROUPEEG)
                        maps(:,:,k) = GROUPEEG(k).individual_microstate_maps{j}';
                    end
                
                if handles.individual.Value == 1 % If new individual clusters were generated here,
                    % >>FIRST NEED TO SORT ALL THE MAPS
                    % Get all possible permutationss
                    fprintf(' >> Sorting individual clusters within this group\n');
                    permutations = perms(1:j);
                    
                    % Rearrange based on first set of maps
                    for p = 1:size(maps,3)
                        
                        % Get unsigned correlations between all maps and the first set of maps
                        correlations = corr(maps(:,:,1)',maps(:,:,p)');
                        % Calculate the summed correlations for each row in permutations
                        summed_corr = zeros(size(permutations,1),1);
                        for n = 1:size(permutations,1) % for each row in permutations
                            for k = 1:size(permutations,2) % for each col in permutations
                                summed_corr(n) = summed_corr(n) + abs(correlations(k,permutations(n,k)));
                            end
                        end
                        % The best reassignment is the maximum of summed_corr
                        [~,index] = max(summed_corr);
                        % Idx is the correct row of permutations
                        best_switch = permutations(index,:);
                        for n = 1:j
                            sorted_maps(n,:,p) = maps(best_switch(n),:,p);
                            if correlations(n,best_switch(n))<0
                                sorted_maps(n,:,p) = sorted_maps(n,:,p) * -1;
                            end
                        end
                    end
                    maps = sorted_maps;
                end
                
                % >>DONE SORTING - NOW AVERAGE
                % Perform point-by-point averaging
                fprintf(' >> Averaging individual clusters within this group\n');
                group_clusters = mean(maps,3);
            end
            
            % Update GROUPEEG
            for k = 1:length(GROUPEEG)
                GROUPEEG(k).group_microstate_maps{j} = group_clusters';
            end
            
            fprintf('...Done.\n');
            
        end
        
        % After all # of microstates are found, put back in ALLEEG
        ALLEEG(idx) = GROUPEEG;
    end
    
    % Plot the resulting group maps
    for i = range(1):range(2) % A separate figure for each # of microstates
        figure;
        set(gcf,'numbertitle','off','name',['BY GROUP: ',num2str(i),' Clusters'])
        for j = 1:length(unique_groups) % Each row is a different group
            subplot(length(unique_groups),i+1,(i+1)*j-i);
            text(0.5,0.5,['Group ',unique_groups(j)]);
            axis off;
            % Find the first member in this group
            first_member = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).group_microstate_maps{i};
            chanlocs = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).chanlocs;
            for k = 1:i % For each map in this group
                % Plot this map here
                subplot(length(unique_groups),i+1,(i+1)*j-i+k);
                topoplot(first_member(:,k),chanlocs);
            end
        end
    end
    assignin('base','ALLEEG',ALLEEG);
end

%% Cluster by condition
need_to_cluster = 0;
if handles.condition.Value == 1
    fprintf('\nClustering condition maps...\n');
    % Create a group_microstates
    if ~isfield(ALLEEG,'condition_microstate_maps')
    ALLEEG(1).condition_microstate_maps = [];
    end
    % Concatenate the group clusters
    group_labels = cat(1,{ALLEEG.condition});
    % Remove the empty groups and convert to strings
    for i = 1:length(group_labels)
        if isnumeric(group_labels{i})
            group_labels{i} = num2str(group_labels{i});
        end
        if isempty(group_labels{i})
            group_labels{i} = '';
        end
    end
    % Find the unique group_labels, and eliminate blank groups
    unique_groups = unique(group_labels);
    unique_groups(strcmp(unique_groups,'')) = [];
    
    for i = 1:length(unique_groups) % FOR EACH GROUP
        
        fprintf(['\nCONDITION ',num2str(i),'\n']);
        
        % Get members of this group
        fprintf(['Getting members of condition ',num2str(i),'...']);
        idx = strcmp(group_labels,unique_groups(i));
        GROUPEEG = ALLEEG(idx);
        fprintf('Done.\n');
        
        for j = range(1):range(2) % For each number of microstates,
            
            fprintf(['\nFinding ',num2str(j),' clusters within condition ',num2str(i),'...\n']);
            
            % Get group data to cluster
            group_clusters = [];
            % All original maps
            if handles.all_maps.Value == 1
                fprintf(' >> Clustering all individual maps\n');
                for k = 1:length(GROUPEEG)
                    for t = 1:size(GROUPEEG(k).gfp_peaks,2)
                        group_clusters = cat(2,group_clusters,GROUPEEG(k).gfp_peaks{t});
                    end
                end
                need_to_cluster = 1;
            end
            % Cluster individual clusters
            if handles.clust_ind_maps.Value == 1
                fprintf(' >> Clustering individual clusters\n');
                for k = 1:length(GROUPEEG)
                    group_clusters = cat(2,group_clusters,GROUPEEG(k).individual_microstate_maps{j});
                end
                need_to_cluster = 1;
            end
            % Percent original maps
            if handles.percent_originals.Value == 1
                fprintf(' >> Clustering using percent originals method\n');
                for k = 1:length(GROUPEEG)
                    group_clusters = cat(2,group_clusters,datasample(cat(2,GROUPEEG(k).gfp_peaks{:}),select_this_many,2));
                end
                need_to_cluster = 1;
            end
            
            % Cluster if need to cluster
            if need_to_cluster == 1
                fprintf(' >> Initializing clustering\n');

                if handles.kmeans.Value == 1
                    [group_clusters,~,~] = find_microstates_kmeans(group_clusters',j,5,2000);
                else
                    group_clusters = find_microstates_taahc(group_clusters',[j j]);
                    group_clusters = group_clusters{j};
                end
            end
            
            % Average individual clusters
            if handles.avg_ind_maps.Value == 1
                fprintf(' >> Averaging indidividual clusters\n');
                
                                    % Generate map matrix
                    maps = [];
                    for k = 1:length(GROUPEEG)
                        maps(:,:,k) = GROUPEEG(k).individual_microstate_maps{j}';
                    end
                
                if handles.individual.Value == 1 % If new individual clusters were generated here,
                    % >> FIRST NEED TO SORT ALL THE MAPS
                    % Get all possible permutationss
                    fprintf(' >> Sorting individual clusters within this condition\n');
                    permutations = perms(1:j);

                    % Rearrange based on first set of maps
                    for p = 1:size(maps,3)
    
                        % Get unsigned correlations between all maps and the first set of maps
                        correlations = corr(maps(:,:,1)',maps(:,:,p)');
                        % Calculate the summed correlations for each row in permutations
                        summed_corr = zeros(size(permutations,1),1);
                        for n = 1:size(permutations,1) % for each row in permutations
                            for k = 1:size(permutations,2) % for each col in permutations
                                summed_corr(n) = summed_corr(n) + abs(correlations(k,permutations(n,k)));
                            end
                        end
                        % The best reassignment is the maximum of summed_corr
                        [~,index] = max(summed_corr);
                        % Idx is the correct row of permutations
                        best_switch = permutations(index,:);
                        for n = 1:j
                            sorted_maps(n,:,p) = maps(best_switch(n),:,p);
                            if correlations(n,best_switch(n))<0
                                sorted_maps(n,:,p) = sorted_maps(n,:,p) * -1;
                            end
                        end
                    end
                    maps = sorted_maps;
                end
                
                % >> DONE SORTING - NOW AVERAGE
                % Perform point-by-point averaging
                fprintf(' >> Averaging individual clusters within this condition\n');
                group_clusters = mean(maps,3);
            end
            % Update GROUPEEG
            for k = 1:length(GROUPEEG)
                GROUPEEG(k).condition_microstate_maps{j} = group_clusters';
            end
            fprintf('...Done.\n');
        end
        % After all # of microstates are found, put back in ALLEEG
        ALLEEG(idx) = GROUPEEG;
    end
    
    % Plot the resulting group maps
    for i = range(1):range(2) % A separate figure for each # of microstates
        figure;
        set(gcf,'numbertitle','off','name',['BY CONDITION: ',num2str(i),' Clusters'])
        for j = 1:length(unique_groups) % Each row is a different group
            subplot(length(unique_groups),i+1,(i+1)*j-i);
            text(0.5,0.5,['Condition ',unique_groups(j)]);
            axis off;
            % Find the first member in this group
            first_member = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).condition_microstate_maps{i};
            chanlocs = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).chanlocs;
            for k = 1:i % For each map in this group
                % Plot this map here
                subplot(length(unique_groups),i+1,(i+1)*j-i+k);
                topoplot(first_member(:,k),chanlocs);
            end
        end
    end
    assignin('base','ALLEEG',ALLEEG);
end

%% Cluster by group x condition



need_to_cluster = 0;
if handles.groupxcondition.Value == 1
    fprintf('\nClustering [group x condition] maps...\n');
    % Create a groupxcondition_microstates
    if ~isfield(ALLEEG,'groupxcondition_microstate_maps')
    ALLEEG(1).groupxcondition_microstate_maps = [];
    end
    % Concatenate the group clusters
    group_labels = cat(1,{ALLEEG.group});
    % Remove the empty groups and convert to strings
    for i = 1:length(group_labels)
        if isnumeric(group_labels{i})
            group_labels{i} = num2str(group_labels{i});
        end
        if isempty(group_labels{i})
            group_labels{i} = '';
        end
    end
    % Eliminate blank groups
    group_labels(strcmp(group_labels,'')) = [];
    
    % Concatenate the condition clusters
    condition_labels = cat(1,{ALLEEG.condition});
    % Remove the empty groups and convert to strings
    for i = 1:length(condition_labels)
        if isnumeric(condition_labels{i})
            condition_labels{i} = num2str(condition_labels{i});
        end
        if isempty(condition_labels{i})
            condition_labels{i} = '';
        end
    end
    % Eliminate blank conditions
    condition_labels(strcmp(condition_labels,'')) = [];
    
    if numel(group_labels) == numel(condition_labels)
        
        groupxcondition_labels = {};
        for i = 1:numel(condition_labels)
            groupxcondition_labels{i} = [group_labels{i},'_',condition_labels{i}];
        end
        
        group_labels = groupxcondition_labels;
        
        unique_groups = unique(group_labels);
        
        
        
        for i = 1:length(unique_groups) % FOR EACH GROUP
            
            fprintf(['\nGROUP x CONDITION ',num2str(i),'\n']);
            
            % Get members of this group
            fprintf(['Getting members of group x condition ',num2str(i),'...']);
            idx = strcmp(group_labels,unique_groups(i));
            GROUPEEG = ALLEEG(idx);
            fprintf('Done.\n');
            
            for j = range(1):range(2) % For each number of microstates,
                
                fprintf(['\nFinding ',num2str(j),' clusters within group x condition ',num2str(i),'...\n']);
                
                % Get group data to cluster
                group_clusters = [];
                % All original maps
                if handles.all_maps.Value == 1
                    fprintf(' >> Clustering all individual maps\n');
                    for k = 1:length(GROUPEEG)
                        for t = 1:size(GROUPEEG(k).gfp_peaks,2)
                            group_clusters = cat(2,group_clusters,GROUPEEG(k).gfp_peaks{t});
                        end
                    end
                    need_to_cluster = 1;
                end
                % Cluster individual clusters
                if handles.clust_ind_maps.Value == 1
                    fprintf(' >> Clustering individual clusters\n');
                    for k = 1:length(GROUPEEG)
                        group_clusters = cat(2,group_clusters,GROUPEEG(k).individual_microstate_maps{j});
                    end
                    need_to_cluster = 1;
                end
                % Percent original maps
                if handles.percent_originals.Value == 1
                    fprintf(' >> Clustering using percent originals method\n');
                    for k = 1:length(GROUPEEG)
                        group_clusters = cat(2,group_clusters,datasample(cat(2,GROUPEEG(k).gfp_peaks{:}),select_this_many,2));
                    end
                    need_to_cluster = 1;
                end
                
                % Cluster if need to cluster
                if need_to_cluster == 1
                    fprintf(' >> Initializing clustering\n');
                  
                    if handles.kmeans.Value == 1
                        [group_clusters,~,~] = find_microstates_kmeans(group_clusters',j,5,2000);
                    else
                        group_clusters = find_microstates_taahc(group_clusters',[j j]);
                        group_clusters = group_clusters{j};
                    end
                end
                
                % Average individual clusters
                if handles.avg_ind_maps.Value == 1
                    fprintf(' >> Averaging indidividual clusters\n');
                                            % Generate map matrix
                        maps = [];
                        for k = 1:length(GROUPEEG)
                            maps(:,:,k) = GROUPEEG(k).individual_microstate_maps{j}';
                        end
                    if handles.individual.Value == 1 % If new individual clusters were generated here,
                        
                        % >> FIRST NEED TO SORT ALL THE MAPS
                        % Get all possible permutationss
                        fprintf(' >> Sorting individual clusters within this condition\n');
                        permutations = perms(1:j);

                        % Rearrange based on first set of maps
                        for p = 1:size(maps,3)
                            
                            % Get unsigned correlations between all maps and the first set of maps
                            correlations = corr(maps(:,:,1)',maps(:,:,p)');
                            % Calculate the summed correlations for each row in permutations
                            summed_corr = zeros(size(permutations,1),1);
                            for n = 1:size(permutations,1) % for each row in permutations
                                for k = 1:size(permutations,2) % for each col in permutations
                                    summed_corr(n) = summed_corr(n) + abs(correlations(k,permutations(n,k)));
                                end
                            end
                            % The best reassignment is the maximum of summed_corr
                            [~,index] = max(summed_corr);
                            % Idx is the correct row of permutations
                            best_switch = permutations(index,:);
                            for n = 1:j
                                sorted_maps(n,:,p) = maps(best_switch(n),:,p);
                                if correlations(n,best_switch(n))<0
                                    sorted_maps(n,:,p) = sorted_maps(n,:,p) * -1;
                                end
                            end
                        end
                        maps = sorted_maps;
                    end
                    % >> DONE SORTING - NOW AVERAGE
                    % Perform point-by-point averaging
                    fprintf(' >> Averaging individual clusters within this group x condition\n');
                    group_clusters = mean(maps,3);
                end
                % Update GROUPEEG
                for k = 1:length(GROUPEEG)
                    GROUPEEG(k).groupxcondition_microstate_maps{j} = group_clusters';
                end
                fprintf('...Done.\n');
            end
            % After all # of microstates are found, put back in ALLEEG
            ALLEEG(idx) = GROUPEEG;
        end
        
        % Plot the resulting group maps
        for i = range(1):range(2) % A separate figure for each # of microstates
            figure;
            set(gcf,'numbertitle','off','name',['BY CONDITION: ',num2str(i),' Clusters'])
            for j = 1:length(unique_groups) % Each row is a different group
                subplot(length(unique_groups),i+1,(i+1)*j-i);
                text(0.5,0.5,['Group x Condition ',unique_groups(j)],'Interpreter','none');
                axis off;
                % Find the first member in this group
                first_member = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).groupxcondition_microstate_maps{i};
                chanlocs = ALLEEG(find(strcmp(group_labels,unique_groups(j)),1)).chanlocs;
                for k = 1:i % For each map in this group
                    % Plot this map here
                    subplot(length(unique_groups),i+1,(i+1)*j-i+k);
                    topoplot(first_member(:,k),chanlocs);
                end
            end
        end
    else
        disp('Group or Condition labels are missing.');
    end
    
    assignin('base','ALLEEG',ALLEEG);
    
end

%% Cluster by global
if handles.glob.Value == 1
    need_to_cluster = 0;
    % Create "global microstate maps" in ALLEEG
    if ~isfield(ALLEEG,'global_microstate_maps')
    ALLEEG(1).global_microstate_maps = [];
    end
    
    fprintf('\nClustering globally...\n');
    
    for j = range(1):range(2) % For each number of microstates,
        
        fprintf(['\nFinding ',num2str(j),' global clusters...\n']);
        
        % Get group data to cluster
        group_clusters = [];
        % All original maps
        if handles.all_maps.Value == 1
            fprintf(' >> Clustering all individual maps\n');
            for k = 1:length(ALLEEG)
                for t = 1:size(ALLEEG(k).gfp_peaks,2)
                    group_clusters = cat(2,group_clusters,ALLEEG(k).gfp_peaks{t});
                end
            end
            need_to_cluster = 1;
        end
        % Cluster individual clusters
        if handles.clust_ind_maps.Value == 1
            fprintf(' >> Clustering individual clusters\n');
            for k = 1:length(ALLEEG)
                group_clusters = cat(2,group_clusters,ALLEEG(k).individual_microstate_maps{j});
            end
            need_to_cluster = 1;
        end
        % Percent original maps
        if handles.percent_originals.Value == 1
            fprintf(' >> Clustering using percent originals method\n');
            for k = 1:length(ALLEEG)
                group_clusters = cat(2,group_clusters,datasample(cat(2,ALLEEG(k).gfp_peaks{:}),select_this_many,2));
            end
            need_to_cluster = 1;
        end
        
        % Cluster if need to cluster
        if need_to_cluster == 1
            fprintf(' >> Initializing clustering\n');
        
            if handles.kmeans.Value == 1
                [group_clusters,~,~] = find_microstates_kmeans(group_clusters',j,5,2000);
            else
                group_clusters = find_microstates_taahc(group_clusters',[j j]);
                group_clusters = group_clusters{j};
            end
        end
        
        % Average individual clusters
        if handles.avg_ind_maps.Value == 1
            fprintf(' >> Averaging indidividual clusters\n');
                            maps = [];
                for k = 1:length(ALLEEG)
                    maps(:,:,k) = ALLEEG(k).individual_microstate_maps{j}';
                end
            if handles.individual.Value == 1 % If new individual clusters were generated here,
                
                % >> FIRST NEED TO SORT ALL THE MAPS
                % Get all possible permutationss
                fprintf(' >> Sorting individual clusters within this condition\n');
                permutations = perms(1:j);
                % Generate map matrix

                % Rearrange based on first set of maps
                for p = 1:size(maps,3)
                    
                    % Get unsigned correlations between all maps and the first set of maps
                    correlations = corr(maps(:,:,1)',maps(:,:,p)');
                    % Calculate the summed correlations for each row in permutations
                    summed_corr = zeros(size(permutations,1),1);
                    for n = 1:size(permutations,1) % for each row in permutations
                        for k = 1:size(permutations,2) % for each col in permutations
                            summed_corr(n) = summed_corr(n) + abs(correlations(k,permutations(n,k)));
                        end
                    end
                    % The best reassignment is the maximum of summed_corr
                    [~,index] = max(summed_corr);
                    % Idx is the correct row of permutations
                    best_switch = permutations(index,:);
                    for n = 1:j
                        sorted_maps(n,:,p) = maps(best_switch(n),:,p);
                        if correlations(n,best_switch(n))<0
                            sorted_maps(n,:,p) = sorted_maps(n,:,p) * -1;
                        end
                    end
                end
                maps = sorted_maps;
            end
            % >> DONE SORTING - NOW AVERAGE
            % Perform point-by-point averaging
            fprintf(' >> Averaging individual clusters within this condition\n');
            group_clusters = mean(maps,3);
        end
        % Update ALLEEG
        for k = 1:length(ALLEEG)
            ALLEEG(k).global_microstate_maps{j} = group_clusters';
        end
        fprintf('...Done.\n');
    end
    
    % Plot the resulting global maps
    figure;
    set(gcf,'numbertitle','off','name','Global Clusters');
    for i = range(1):range(2) % for each number of clusters
        for j = 1:i % for each map in this range
            subplot(range(2)-range(1)+1,range(2),range(2)*(i-range(1)+1)-range(2)+j);
            topoplot(ALLEEG(1).global_microstate_maps{i}(:,j),ALLEEG(1).chanlocs);
        end
    end
    
    assignin('base','ALLEEG',ALLEEG);
    
end

%% Update handles structure
handles.ALLEEG = ALLEEG;
guidata(hObject, handles);


%% Close GUI
figure1_CloseRequestFcn(handles.figure1, eventdata, handles);


% --- Executes on button press in individual.
function individual_Callback(hObject, eventdata, handles)
% hObject    handle to individual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of individual

% --- Executes on button press in group.
function group_Callback(hObject, eventdata, handles)
% hObject    handle to group (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of group
group_enable(handles);


% --- Executes on button press in condition.
function condition_Callback(hObject, eventdata, handles)
% hObject    handle to condition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of condition
group_enable(handles);


% --- Executes on button press in groupxcondition.
function groupxcondition_Callback(hObject, eventdata, handles)
% hObject    handle to groupxcondition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of groupxcondition
group_enable(handles);


% --- Executes on button press in glob.
function glob_Callback(hObject, eventdata, handles)
% hObject    handle to glob (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of glob
group_enable(handles);


% --- Enables/disables group clustering options.
function group_enable(handles)
if sum([handles.group.Value handles.condition.Value handles.groupxcondition.Value handles.glob.Value]) > 0
    handles.all_maps.Enable = 'on';
    handles.avg_ind_maps.Enable = 'on';
    handles.clust_ind_maps.Enable = 'on';
    handles.percent_originals.Enable = 'on';
    if handles.percent_originals.Value == 1
        handles.percent_edit.Enable = 'on';
    end
    if ((~isfield(handles.ALLEEG, 'individual_microstate_maps') || isempty(handles.ALLEEG(1).individual_microstate_maps)) && handles.all_maps.Value == 0 && handles.percent_originals.Value == 0)
        handles.individual.Value = 1;
        handles.individual.Enable = 'off';
    else
        handles.individual.Enable = 'on';
    end
else
    handles.all_maps.Enable = 'off';
    handles.avg_ind_maps.Enable = 'off';
    handles.clust_ind_maps.Enable = 'off';
    handles.percent_originals.Enable = 'off';
    handles.percent_edit.Enable = 'off';
    handles.individual.Enable = 'on';
end


function percent_originals_Callback(hObject, eventdata, handles)
% hObject    handle to percent_originals (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1
group_enable(handles)
handles.percent_edit.Enable = 'on';


function clust_ind_maps_Callback(hObject, eventdata, handles)
% hObject    handle to percent_originals (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1
group_enable(handles)
handles.percent_edit.Enable = 'off';


function avg_ind_maps_Callback(hObject, eventdata, handles)
% hObject    handle to percent_originals (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1
group_enable(handles)
handles.percent_edit.Enable = 'off';
if handles.individual.Value == 1 % If new individual clusters are about to be made,
    handles.prompt_text.String = 'Individual clusters generated here will be auto-sorted to make group clusters.';
else
    handles.prompt_text.String = 'IMPORTANT: Individual clusters should be sorted before generating these group clusters!!!';
end


function all_maps_Callback(hObject, eventdata, handles)
% hObject    handle to percent_originals (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1
group_enable(handles)
handles.percent_edit.Enable = 'off';


function percent_edit_Callback(hObject, eventdata, handles)
% hObject    handle to percent_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of percent_edit as text
%        str2double(get(hObject,'String')) returns contents of percent_edit as a double

function min_clusters_Callback(hObject, eventdata, handles)
% hObject    handle to min_clusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of min_clusters as text
%        str2double(get(hObject,'String')) returns contents of min_clusters as a double
if isnan(str2double(get(hObject,'String'))) || str2double(get(hObject,'String')) < 0
    handles.prompt_text.String = 'Error: minimum clusters must be a positive integer.';
    handles.min_clusters.String = '1';
end
if str2double(handles.min_clusters.String) > str2double(handles.max_clusters.String)
    handles.prompt_text.String = 'Minimum clusters must be less than or equal to maximum clusters.';
    handles.max_clusters.String = handles.min_clusters.String;
else
    handles.prompt_text.String = '';
end

% --- Executes during object creation, after setting all properties.
function min_clusters_CreateFcn(hObject, eventdata, handles)
% hObject    handle to min_clusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function max_clusters_Callback(hObject, eventdata, handles)
% hObject    handle to max_clusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of max_clusters as text
%        str2double(get(hObject,'String')) returns contents of max_clusters as a double
if isnan(str2double(get(hObject,'String'))) || str2double(get(hObject,'String')) < 0
    handles.prompt_text.String = 'Error: maximum clusters must be a positive integer.';
    handles.min_clusters.String = '4';
end
if str2double(handles.min_clusters.String) > str2double(handles.max_clusters.String)
    handles.prompt_text.String = 'Minimum clusters must be less than or equal to maximum clusters.';
    handles.max_clusters.String = handles.min_clusters.String;
else
    handles.prompt_text.String = '';
end

% --- Executes during object creation, after setting all properties.
function max_clusters_CreateFcn(hObject, eventdata, handles)
% hObject    handle to max_clusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in taahc.
function taahc_Callback(hObject, eventdata, handles)
% hObject    handle to taahc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of taahc
handles.prompt_text.String = 'Warning: TAAHC works, but is very slow on most personal systems. I suggest using k-means until a faster TAAHC method is developed.';
