function varargout = microstate_analysis(varargin)
% MICROSTATE_ANALYSIS MATLAB code for microstate_analysis.fig
%      MICROSTATE_ANALYSIS, by itself, creates a new MICROSTATE_ANALYSIS or raises the existing
%      singleton*.
%
%      H = MICROSTATE_ANALYSIS returns the handle to a new MICROSTATE_ANALYSIS or the handle to
%      the existing singleton*.
%
%      MICROSTATE_ANALYSIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MICROSTATE_ANALYSIS.M with the given input arguments.
%
%      MICROSTATE_ANALYSIS('Property','Value',...) creates a new MICROSTATE_ANALYSIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before microstate_analysis_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to microstate_analysis_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help microstate_analysis

% Last Modified by GUIDE v2.5 11-Aug-2016 14:47:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @microstate_analysis_OpeningFcn, ...
    'gui_OutputFcn',  @microstate_analysis_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before microstate_analysis is made visible.
function microstate_analysis_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to microstate_analysis (see VARARGIN)

% Choose default command line output for microstate_analysis
handles.output = hObject;

fprintf('Getting ALLEEG from base workspace...');
handles.ALLEEG = evalin('base','ALLEEG');
fprintf('Done.\n');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes microstate_analysis wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = microstate_analysis_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Collect all the outputs
varargout{1} = [handles.output];

% The figure can be deleted now
delete(handles.figure1);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure

if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end


% --- Executes on button press in extract_gfp_peaks.
function extract_gfp_peaks_Callback(hObject, eventdata, handles)
% hObject    handle to extract_gfp_peaks (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ALLEEG = handles.ALLEEG;

fprintf('Extracting GFP peaks (original maps) from data.\n');

for i = 1:length(ALLEEG) % loop through all files in ALLEEG
    
    fprintf(['File ',num2str(i),' of ',num2str(length(ALLEEG)),'...']);
    
    % get all the data
    data = permute(ALLEEG(i).data,[2 1 3]);
    % using permute to reorganize the EEGLab data structure
    
    % use ALLEEG.badtr to remove rejected epochs
    %     if ~isempty(ALLEEG(i).badtr)
    %         idx = zeros(size(data,3),1);
    %         idx(ALLEEG(i).badtr) = 1;
    %         data(:,:,idx) = [];
    %     end
    
    % Clear peaks and times
    peaks=[];
    times=[];
    
    for j = 1:size(data,3) % for each epoch
        [peaks{j},times{j}] = gfp_peaks(data(:,:,j));
        peaks{j} = peaks{j}';
        times{j} = times{j}';
    end
    
    % place back in ALLEEG
    ALLEEG(i).gfp_peaks = peaks;
    ALLEEG(i).gfp_times = times;
    
    fprintf('Done.\n');
    
end

fprintf('Finished extracting GFP peaks.\n');

handles.extract_gfp_peaks.BackgroundColor = [0 1 0];

% Update handles structure
handles.ALLEEG = ALLEEG;
guidata(hObject, handles);

% Pass ALLEEG to workspace
assignin('base','ALLEEG',handles.ALLEEG);


% --- Executes on button press in cluster.
function cluster_Callback(hObject, eventdata, handles)
% hObject    handle to cluster (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.ALLEEG = clustering_gui(handles.ALLEEG);

handles.cluster.BackgroundColor = [0 1 0];

% Update handles structure
guidata(hObject, handles);

% Pass ALLEEG to workspace
assignin('base','ALLEEG',handles.ALLEEG);


% --- Executes on button press in eval.
function eval_Callback(hObject, eventdata, handles)
% hObject    handle to eval (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fprintf('Evaluating clusters...\n');

ALLEEG = handles.ALLEEG;

groupings = {'individual','group','condition','groupxcondition','global'};

for eval_by = groupings
    % initialize result arrays
    filenames = cat(1,{ALLEEG.filename})';
    gev = NaN(length(ALLEEG),length(ALLEEG(1).individual_microstate_maps));
    cv = NaN(length(ALLEEG),length(ALLEEG(1).individual_microstate_maps));
    skip = 0; % should I skip this output?
    
    fprintf(['Evaluating ',char(eval_by),' maps...']);
    
    for i = 1:length(ALLEEG) % for each file in ALLEEG
        fprintf('>');
        
        switch char(eval_by)
            
            case 'individual'
                
                if isfield(ALLEEG,'individual_microstate_maps')
                    for j = 1:size(ALLEEG(i).individual_microstate_maps,2) % for each number of microstates
                        if ~isempty(ALLEEG(i).individual_microstate_maps{j}) % make sure that there are maps here
                            [gev(i,j),cv(i,j)] = eval_clusters(ALLEEG(i).individual_microstate_maps{j}',cat(2,ALLEEG(i).gfp_peaks{:})');
                        end
                    end
                    % Put back in ALLEEG
                    ALLEEG(i).individual_gev = gev(i,:);
                    ALLEEG(i).individual_cv = cv(i,:);
                else
                    skip = 1;
                end
            case 'global'
                if isfield(ALLEEG,'global_microstate_maps')
                    for j = 1:size(ALLEEG(i).global_microstate_maps,2) % for each number of microstates
                        if ~isempty(ALLEEG(i).global_microstate_maps{j}) % make sure that there are maps here
                            [gev(i,j),cv(i,j)] = eval_clusters(ALLEEG(i).global_microstate_maps{j}',cat(2,ALLEEG(i).gfp_peaks{:})');
                        end
                    end
                    % Put back in ALLEEG
                    ALLEEG(i).global_gev = gev(i,:);
                    ALLEEG(i).global_cv = cv(i,:);
                else
                    skip = 1 ;
                end
            case 'group'
                if isfield(ALLEEG,'group_microstate_maps')
                    for j = 1:size(ALLEEG(i).group_microstate_maps,2) % for each number of microstates
                        if ~isempty(ALLEEG(i).group_microstate_maps{j}) % make sure that there are maps here
                            [gev(i,j),cv(i,j)] = eval_clusters(ALLEEG(i).group_microstate_maps{j}',cat(2,ALLEEG(i).gfp_peaks{:})');
                        end
                    end
                    % Put back in ALLEEG
                    ALLEEG(i).group_gev = gev(i,:);
                    ALLEEG(i).group_cv = cv(i,:);
                else 
                    skip = 1;
                end
            case 'condition'
                if isfield(ALLEEG,'condition_microstate_maps')
                    for j = 1:size(ALLEEG(i).condition_microstate_maps,2) % for each number of microstates
                        if ~isempty(ALLEEG(i).condition_microstate_maps{j}) % make sure that there are maps here
                            [gev(i,j),cv(i,j)] = eval_clusters(ALLEEG(i).condition_microstate_maps{j}',cat(2,ALLEEG(i).gfp_peaks{:})');
                        end
                    end
                    % Put back in ALLEEG
                    ALLEEG(i).group_gev = gev(i,:);
                    ALLEEG(i).group_cv = cv(i,:);
                else
                    skip = 1;
                end
            case 'groupxcondition'
                if isfield(ALLEEG,'groupxcondition_microstate_maps')
                    for j = 1:size(ALLEEG(i).groupxcondition_microstate_maps,2) % for each number of microstates
                        if ~isempty(ALLEEG(i).groupxcondition_microstate_maps{j}) % make sure that there are maps here
                            [gev(i,j),cv(i,j)] = eval_clusters(ALLEEG(i).groupxcondition_microstate_maps{j}',cat(2,ALLEEG(i).gfp_peaks{:})');
                        end
                    end
                    % Put back in ALLEEG
                    ALLEEG(i).groupxcondition_gev = gev(i,:);
                    ALLEEG(i).groupxcondition_cv = cv(i,:);
                else
                    skip = 1;
                end
            otherwise
                
                skip = 1;
                
        end
                
    end
    
    fprintf('...Done.\n');
    
    if skip == 0
    %% Display GEV results in a table
    % calculate mean of all gev values
    mean_gev = mean(gev);
    gev = cat(1,gev,mean_gev);
    filenames = cat(1,filenames,{'***GRAND MEAN***'});
    % display results
    fprintf(['GEV results for ',char(eval_by),' microstates:\n']);
    gev_table = array2table(gev);
    gev_table.Properties.RowNames = filenames
    
    %% Display CV results in a table; add a row showing where it is minimized
    % where is CV minimized?
    [~,min_cv] = min(cv,[],2);
    % display results
    fprintf(['CV results for ',char(eval_by),' microstates:\n']);
    cv_table = [array2table(cv) array2table(min_cv)];
    cv_table.Properties.RowNames = filenames(1:end-1)
    fprintf(['In this sample, the mean CV minimum is at ',num2str(mean(min_cv)),' clusters.\n']);
    end
    
end

% Update handles
handles.ALLEEG = ALLEEG;
guidata(hObject, handles);
assignin('base','ALLEEG',handles.ALLEEG);
handles.eval.BackgroundColor = [0 1 0];

fprintf('\nEvaluation of all clusters is complete.\n');


% --- Executes on button press in sort.
function sort_Callback(hObject, eventdata, handles)
% hObject    handle to sort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ALLEEG = handles.ALLEEG;

rearrange_by = handles.type.Value;
microstates = str2double(handles.microstates.String);

switch rearrange_by
    case 1 % individual maps 
        % rearrange each individual set of maps
        
        % Concatenate the file labels
        row_names = cat(1,{ALLEEG.filename});
        % Remove the empty labels and convert to strings
        for i = 1:length(row_names)
            if isnumeric(row_names{i})
                row_names{i} = num2str(row_names{i});
            end
            if isempty(row_names{i})
                row_names{i} = '';
            end
        end
        
        % concatenate all individual microstate maps
        sort_me = [];
        for i = 1:length(ALLEEG)
            sort_me = cat(3,sort_me,ALLEEG(i).individual_microstate_maps{microstates}');
        end
        
        % sort using sort_maps_gui
        sort_me = sort_maps_gui(sort_me,ALLEEG(1).chanlocs,row_names);
        
        % put back in ALLEEG
        if ~isnan(sort_me) % sort_maps_gui will give NaN if sorting is not performed
            sort_me = permute(sort_me,[2 1 3]);
            for i = 1:length(ALLEEG)
                ALLEEG(i).individual_microstate_maps{microstates} = sort_me(:,:,i);
            end
        end
        
    case 2 % Group maps
        % rearrange the group maps
        
        % Concatenate the group labels
        group_labels = cat(1,{ALLEEG.group});
        % Remove the empty groups and convert to strings
        for i = 1:length(group_labels)
            if isnumeric(group_labels{i})
                group_labels{i} = num2str(group_labels{i});
            end
            if isempty(group_labels{i})
                group_labels{i} = '';
            end
        end
        % Find the unique group_labels, and eliminate blank groups
        group_labels(strcmp(group_labels,'')) = [];
        [row_names,unique_group_indices,unique_group_labels] = unique(group_labels);
        sort_me = [];
        for i = unique_group_indices'
            % add these to sort_me
            sort_me = cat(3,sort_me,ALLEEG(i).group_microstate_maps{microstates}');
        end
        % submit sort_me to sort_me_gui
        sort_me = sort_maps_gui(sort_me,ALLEEG(1).chanlocs,row_names);
        % now that they are sorted, put them back into ALLEEG
        if ~isnan(sort_me) % sort_maps_gui will give NaN if sorting is not performed
            for i = 1:length(ALLEEG)
                ALLEEG(i).group_microstate_maps{microstates} = sort_me(:,:,unique_group_labels(i))';
            end
        end
        
    case 3 % Condition maps
        % rearrange the condition maps
        
        % Concatenate the group labels
        group_labels = cat(1,{ALLEEG.condition});
        % Remove the empty groups and convert to strings
        for i = 1:length(group_labels)
            if isnumeric(group_labels{i})
                group_labels{i} = num2str(group_labels{i});
            end
            if isempty(group_labels{i})
                group_labels{i} = '';
            end
        end
        % Find the unique group_labels, and eliminate blank groups
        group_labels(strcmp(group_labels,'')) = [];
        [row_names,unique_group_indices,unique_group_labels] = unique(group_labels);
        sort_me = [];
        for i = unique_group_indices'
            % add these to sort_me
            sort_me = cat(3,sort_me,ALLEEG(i).condition_microstate_maps{microstates}');
        end
        % submit sort_me to sort_me_gui
        sort_me = sort_maps_gui(sort_me,ALLEEG(1).chanlocs,row_names);
        % now that they are sorted, put them back into ALLEEG
        if ~isnan(sort_me) % sort_maps_gui will give NaN if sorting is not performed
            for i = 1:length(ALLEEG)
                ALLEEG(i).condition_microstate_maps{microstates} = sort_me(:,:,unique_group_labels(i))';
            end
        end
        
    case 4 % Group x Condition maps
        % rearrange the group x condition maps
        
        % Concatenate the group labels
        group_labels = cat(1,{ALLEEG.group});
        % Remove the empty groups and convert to strings
        for i = 1:length(group_labels)
            if isnumeric(group_labels{i})
                group_labels{i} = num2str(group_labels{i});
            end
            if isempty(group_labels{i})
                group_labels{i} = '';
            end
        end
        % Find the unique group_labels, and eliminate blank groups
        group_labels(strcmp(group_labels,'')) = [];
        
        % Concatenate the condition labels
        condition_labels = cat(1,{ALLEEG.condition});
        % Remove the empty groups and convert to strings
        for i = 1:length(condition_labels)
            if isnumeric(condition_labels{i})
                condition_labels{i} = num2str(condition_labels{i});
            end
            if isempty(condition_labels{i})
                condition_labels{i} = '';
            end
        end
        % Find the unique group_labels, and eliminate blank groups
        condition_labels(strcmp(condition_labels,'')) = [];
        
        if numel(group_labels) == numel(condition_labels)
            
            groupxcondition_labels = {};
            for i = 1:numel(condition_labels)
                groupxcondition_labels{i} = [group_labels{i},'_',condition_labels{i}];
            end
            
            group_labels = groupxcondition_labels;
            
        [row_names,unique_group_indices,unique_group_labels] = unique(group_labels);
        
        sort_me = [];
        for i = unique_group_indices'
            % add these to sort_me
            sort_me = cat(3,sort_me,ALLEEG(i).groupxcondition_microstate_maps{microstates}');
        end
        % submit sort_me to sort_me_gui
        sort_me = sort_maps_gui(sort_me,ALLEEG(1).chanlocs,row_names);
        % now that they are sorted, put them back into ALLEEG
        if ~isnan(sort_me) % sort_maps_gui will give NaN if sorting is not performed
            for i = 1:length(ALLEEG)
                ALLEEG(i).groupxcondition_microstate_maps{microstates} = sort_me(:,:,unique_group_labels(i))';
            end
        end
        else
        disp('Error: Some groups do not have conditions, or vice versa.');
        sort_me = NaN;
        end
    case 5 % global maps
        
        % get the global microstate maps
        sort_me = ALLEEG(1).global_microstate_maps{microstates}';
       
        row_names = {'GLOBAL Maps'};
        
        % sort using sort_me
        sort_me = sort_maps_gui(sort_me,ALLEEG(1).chanlocs,row_names);
        
        % put back in ALLEEG
        if ~isnan(sort_me) % sort_maps_gui will give NaN if sorting is not performed
        for i = 1:length(ALLEEG)
            ALLEEG(i).global_microstate_maps{microstates} = sort_me';
        end
        end
        
    otherwise 
        error('Input not recognized.');
end

% Update handles
handles.ALLEEG = ALLEEG;
guidata(hObject, handles);
assignin('base','ALLEEG',handles.ALLEEG);
if ~isnan(sort_me) % if maps were actually sorted
    handles.sort.BackgroundColor = [0 1 0];
end


% --- Executes on button press in calc.
function calc_Callback(hObject, eventdata, handles)
% hObject    handle to calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% first check to make sure the threshold makes sense
if str2double(handles.threshold.String) >= 0 && str2double(handles.threshold.String) < 1
    
ALLEEG = handles.ALLEEG;    
eval_by = handles.type.Value;
calc_by_epoch = handles.calc_by_epoch.Value;
microstates = str2double(handles.microstates.String);
thresh = str2double(handles.threshold.String);
compiled_results = [];
fprintf('\nCalculating ');

% Clear filenames from previous use
filenames = [];
% Clear subjects from previous use
subjects = [];
% Clear groups from previous use
groups = [];
% Clear conditions from previous use
conditions = [];
% Clear epoch counter from previous use
epoch_counter = [];

for i=1:length(ALLEEG) % for each file in ALLEEG
    
    fprintf(['>>',num2str(i)]);
    
        % constructing input for calc_microstate_features
    
        % get the maps
     switch eval_by
        case 1 % individual
            maps = ALLEEG(i).individual_microstate_maps{microstates}';
        case 2 % group
            maps = ALLEEG(i).group_microstate_maps{microstates}';
        case 3 % condition
            maps = ALLEEG(i).condition_microstate_maps{microstates}';
        case 4 % groupxcondition
            maps = ALLEEG(i).groupxcondition_microstate_maps{microstates}';
        case 5 % global
            maps = ALLEEG(i).global_microstate_maps{microstates}';
        otherwise
            disp('You selection has not been coded yet.');
     end
     
        % get the sampling rate
        srate = ALLEEG(i).srate;
        
        % get the data and run
        
        orig_data = ALLEEG(i).data;
        
        if calc_by_epoch == 0
            % collect all the data and submit together
            data = permute(orig_data,[2 1 3]);
            % get results of all data from calc_microstate_features
            [results,labels] = calc_microstate_features(data,maps,srate,thresh);
            % put these results back into ALLEEG
            ALLEEG(i).microstate_labels{microstates} = labels;
            ALLEEG(i).fitting_results{microstates} = results;
            % add to the filenames/subjects/groups/conditions
            filenames{end+1} = ALLEEG(i).filename;
            subjects{end+1} = ALLEEG(i).subject;
            groups{end+1} = ALLEEG(i).group;
            conditions{end+1} = ALLEEG(i).condition;
            compiled_results = vertcat(compiled_results,results);
            epoch_counter{end+1} = NaN;
        elseif calc_by_epoch == 1 % if calculating by epoch
            for j = 1:size(orig_data,3) % for each epoch
                % collect data in the epoch
                data = permute(orig_data(:,:,j),[2 1]);
                % get results of all data from calc_microstate_features
                [results,labels] = calc_microstate_features(data,maps,srate,thresh);
                % add to the filenames/subjects/groups/conditions
                filenames{end+1} = ALLEEG(i).filename;
                subjects{end+1} = ALLEEG(i).subject;
                groups{end+1} = ALLEEG(i).group;
                conditions{end+1} = ALLEEG(i).condition;
                compiled_results = vertcat(compiled_results,results);
                epoch_counter{end+1} = j;
            end
        end

end

compiled_results = [cell2table(filenames', 'VariableNames', {'Filenames'}) cell2table(subjects','VariableNames',{'Subject'}) cell2table(groups','VariableNames',{'Group'}) cell2table(conditions','VariableNames',{'Condition'}) cell2table(epoch_counter','VariableNames',{'EpochNo'}) compiled_results];
% compiled_results.Properties.RowNames = filenames;
fprintf('>>Done.');
compiled_results

path = uigetdir('','Where to save results?');
prompt = 'Save results as: ';
name = input(prompt,'s');

writetable(compiled_results,fullfile(path,name),'WriteRowNames',1);
    
handles.ALLEEG = ALLEEG;
guidata(hObject, handles);
assignin('base','ALLEEG',handles.ALLEEG);
handles.calc.BackgroundColor = [0 1 0];

else
    disp('Error: Fitting threshold must be between 0 and 1.');
end


% --- Executes on button press in tanova.
function tanova_Callback(hObject, eventdata, handles)
% hObject    handle to tanova (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tanova_gui(handles.ALLEEG);


function microstates_Callback(hObject, eventdata, handles)
% hObject    handle to microstates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of microstates as text
%        str2double(get(hObject,'String')) returns contents of microstates as a double


% --- Executes during object creation, after setting all properties.
function microstates_CreateFcn(hObject, eventdata, handles)
% hObject    handle to microstates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in type.
function type_Callback(hObject, eventdata, handles)
% hObject    handle to type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns type contents as cell array
%        contents{get(hObject,'Value')} returns selected item from type


% --- Executes during object creation, after setting all properties.
function type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function threshold_Callback(hObject, eventdata, handles)
% hObject    handle to threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of threshold as text
%        str2double(get(hObject,'String')) returns contents of threshold as a double

% --- Executes during object creation, after setting all properties.
function threshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in calc_by_epoch.
function calc_by_epoch_Callback(hObject, eventdata, handles)
% hObject    handle to calc_by_epoch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of calc_by_epoch
