function varargout = sort_maps_gui(varargin)
% SORT_MAPS_GUI MATLAB code for sort_maps_gui.fig
%      SORT_MAPS_GUI, by itself, creates a new SORT_MAPS_GUI or raises the existing
%      singleton*.
%
%      H = SORT_MAPS_GUI returns the handle to a new SORT_MAPS_GUI or the handle to
%      the existing singleton*.
%
%      SORT_MAPS_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SORT_MAPS_GUI.M with the given input arguments.
%
%      SORT_MAPS_GUI('Property','Value',...) creates a new SORT_MAPS_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sort_maps_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to sort_maps_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help sort_maps_gui

% Last Modified by GUIDE v2.5 27-Apr-2016 14:07:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @sort_maps_gui_OpeningFcn, ...
    'gui_OutputFcn',  @sort_maps_gui_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before sort_maps_gui is made visible.
function sort_maps_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sort_maps_gui (see VARARGIN)

% Choose default command line output for clustering_gui
handles.output = hObject;

if length(varargin) ~= 3
    error('Incorrect number of arguments.');
end

handles.figure = figure;
handles.maps = varargin{1};
handles.input_maps = handles.maps;
handles.chanlocs = varargin{2};
handles.row_labels = varargin{3};

% Initialize several variables
handles.microstates = size(handles.maps,1); % number of microstates
handles.template_index = 1; % index in maps of desired templates
handles.rearrange.String = num2str(1:handles.microstates);
handles.output = NaN;

update_figure(handles);

% Update handles structure
guidata(hObject, handles);
% UIWAIT makes clustering_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = sort_maps_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = [handles.output];
delete(hObject);

% --- Executes on button press in forward.
function forward_Callback(hObject, eventdata, handles)
% hObject    handle to forward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.template_index = handles.template_index + 1;
if handles.template_index > size(handles.maps,3)
    handles.template_index = 1;
end
if mod(handles.template_index,5) == 1
    update_figure(handles);
else
update_selected(handles);
end

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in back.
function back_Callback(hObject, eventdata, handles)
% hObject    handle to back (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.template_index = handles.template_index - 1;
if handles.template_index < 1
    handles.template_index = size(handles.maps,3);
end
if mod(handles.template_index,5) == 0
    update_figure(handles);
else
update_selected(handles);
end

% Update handles structure
guidata(hObject, handles);

function rearrange_Callback(hObject, eventdata, handles)
% hObject    handle to rearrange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object creation, after setting all properties.
function rearrange_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rearrange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in done.
function done_Callback(hObject, eventdata, handles)
% hObject    handle to done (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.output = handles.maps;
figure(handles.figure);
close;

%% update handles
guidata(hObject, handles);

figure1_CloseRequestFcn(handles.figure1, eventdata, handles);

% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.maps = handles.input_maps;
handles.template_index = 1;
handles.rearrange.String = num2str(1:handles.microstates);
update_figure(handles);

% update handles
guidata(hObject, handles);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end

% --- Executes on button press in rearrange_button.
function rearrange_button_Callback(hObject, eventdata, handles)
% hObject    handle to rearrange_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch_matrix = str2num(handles.rearrange.String);

if sort(abs(switch_matrix)) == 1:handles.microstates % If the switch matrix looks right,
    
    % Rearrange maps(:,:,template) according to the switch matrix
    temp_switch=[];
    for i=1:handles.microstates
        temp_switch(i,:)=handles.maps(abs(switch_matrix)==i,:,handles.template_index)*switch_matrix(abs(switch_matrix)==i)/abs(switch_matrix(abs(switch_matrix)==i));
    end
    
    handles.maps(:,:,handles.template_index) = temp_switch;
    
else
    disp('Switch matrix has wrong form. Try again.');
    handles.rearrange.String = num2str(1:handles.microstates);
end

update_row(handles);
handles.rearrange.String = num2str(1:handles.microstates);

% update handles
guidata(hObject, handles);

% --- Updates the WHOLE figure
function update_figure(handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fprintf('Plotting, please wait...');
figure(handles.figure)
for j = 1:5 % only plotting 5 rows in each figure to make it readable
    
    % if this is the selected template maps, indicate such
    set(subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates),'visible','off');
    h = subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates);
    cla(h);
    subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates);
    
    if length(handles.row_labels) >= floor((handles.template_index-1)/5)*5+j
        text(0,0.75,handles.row_labels{floor((handles.template_index-1)/5)*5+j},'Interpreter','none');
    end
    
    if mod(handles.template_index,5) == j || (j==5 && mod(handles.template_index,5)==0);
        text(0,0.5,'SELECTED');
    end
    
    % plot the microstates in the remaining columns
    for i = 1:handles.microstates % for each microstate
        h = subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates+i);
        cla(h);
        h = subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates+i);
        
        if size(handles.maps,3) >= floor((handles.template_index-1)/5)*5+j
            topoplot(handles.maps(i,:,floor((handles.template_index-1)/5)*5+j),handles.chanlocs);
            title(['Cluster ',num2str(i)]);
        else
            set(h,'visible','off');
        end
    end
end
fprintf('Done.\n');

% Updates just the SELECTED label
function update_selected(handles)
% select the main figure
figure(handles.figure);

for j=1:5
    % erase what's there
    h = subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates);
    cla(h);
    h = subplot(5,handles.microstates+1,j*(handles.microstates+1)-handles.microstates);
    set(h,'visible','off');
            
    % if this is the template index, indicate as such
    if length(handles.row_labels) >= floor((handles.template_index-1)/5)*5+j
        text(0,0.75,handles.row_labels{floor((handles.template_index-1)/5)*5+j},'Interpreter','none');
    end
    if mod(handles.template_index,5) == j || (j==5 && mod(handles.template_index,5)==0);
        text(0,0.5,'SELECTED');
    end
        
end

% updates just the SELECTED row
function update_row(handles)
% select the main figure
figure(handles.figure);

row_index = mod(handles.template_index,5);
if row_index == 0
    row_index = 5;
end

for i = 1:handles.microstates
    % erase what's in the subplot
    h = subplot(5,handles.microstates+1,row_index*(handles.microstates+1)-handles.microstates+i);
    cla(h);
    subplot(5,handles.microstates+1,row_index*(handles.microstates+1)-handles.microstates+i);
    
    % plot
    topoplot(handles.maps(i,:,handles.template_index),handles.chanlocs);
    title(['Cluster ',num2str(i)]);
end

% --- Executes on button press in sort_all.
function sort_all_Callback(hObject, eventdata, handles)
% hObject    handle to sort_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% Sort all maps in handles.maps based on template_index
fprintf('Sorting, please wait...');

handles.output = zeros(size(handles.maps)); % initialize output matrix

% Get all possible permutationss
permutations = perms(1:handles.microstates);

for i = 1:size(handles.maps,3) % for all sets of maps
    
    % Get unsigned correlations
    correlations = corr(handles.maps(:,:,handles.template_index)',handles.maps(:,:,i)');
    
    % Calculate the summed correlations for each row in permutations
    summed_corr = zeros(size(permutations,1),1);
    for j = 1:size(permutations,1) % for each row in permutations
        for k = 1:size(permutations,2) % for each col in permutations
            summed_corr(j) = summed_corr(j) + abs(correlations(k,permutations(j,k)));
        end
    end
    
    % The best reassignment is the maximum of summed_corr
    [~,idx] = max(summed_corr);
    
    % Idx is the correct row of permutations
    best_switch = permutations(idx,:);
    for j = 1:handles.microstates
        handles.output(j,:,i) = handles.maps(best_switch(j),:,i);
        if correlations(j,best_switch(j))<0
            handles.output(j,:,i) = handles.output(j,:,i) * -1;
        end
    end
    
end

handles.maps = handles.output;

%% update handles
guidata(hObject, handles);

%% Update the figure
update_figure(handles);

fprintf('Done.\n');
