function [ p ] = tanova( group1, group2, reps )
%TANOVA Summary of this function goes here
%   Detailed explanation goes here

%% Concatenate the groups
all_maps = cat(1,group1,group2);

%% Invert maps as necessary to make sure everything is matched
correlations = corr(all_maps(1,:)',all_maps');
all_maps(correlations<0,:) = all_maps(correlations<0,:) * -1;

%% Calculate the real test statistic
real_test_stat = std(mean(all_maps(1:size(group1,1),:))-mean(all_maps((size(group1,1)+1):end,:)));

%% Randomly reshuffle
test_stats = zeros(reps,1);
for i = 1:reps
    
    % Shuffle all_maps
    all_maps = all_maps(randperm(size(all_maps,1)),:);
    
    % Recalculate test statistic
    test_stats(i) = std(mean(all_maps(1:size(group1,1),:))-mean(all_maps((size(group1,1)+1):end,:)));
    
end

%% P value is fraction of test_stats that is above real_test_stat
p = sum(test_stats>real_test_stat)/reps;

end

